diff --git a/CHANGELOG b/CHANGELOG
index 5240cfaf..11d1a02a 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -3,7 +3,7 @@
 1... WLA GB-Z80/Z80/6502/65C02/6510/65816/HUC6280/SPC-700 History
 ------------------------------------------------------------------------------
 
-v9.8 (20-Feb-2019) [ALL] Deprecated section's size giving inside section's
+v9.8 (21-Feb-2019) [ALL] Deprecated section's size giving inside section's
                      name string. (REMOVE WARNING WHEN RELEASING v9.8!)
                    [ALL] Added APPENDTO to .RAMSECTIONs.
                    [ALL] When allocating a new unknown reference, we'll set
@@ -28,6 +28,8 @@ v9.8 (20-Feb-2019) [ALL] Deprecated section's size giving inside section's
                      now also the version's date.
                    [ALL] Added -A to WLALINK - Add address-to-line mapping
                      data to WLA symbol file.
+                   [ALL] WLALINK gives now more information about the cause
+                     when a memory overwrite occurs.
                    [GB ] Added support for .VERSION (Mask ROM version number).
                    [GB ] Fixed the handling of RAMSIZE inside of .GBHEADER.
                    [GB ] New licensee code is set to $0000 if old licensee
diff --git a/examples/gb-z80/background_test/main.s b/examples/gb-z80/background_test/main.s
index 4b2ec002..921be6d1 100644
--- a/examples/gb-z80/background_test/main.s
+++ b/examples/gb-z80/background_test/main.s
@@ -25,7 +25,7 @@
 .ORG 0
 
 	rlc b
-.db $ff, :whereami
+.db "START>", :whereami, "<END"
 
 .section "alku" superfree
 whereami:
diff --git a/wlalink/analyze.c b/wlalink/analyze.c
index 713260f9..c8d542d2 100644
--- a/wlalink/analyze.c
+++ b/wlalink/analyze.c
@@ -36,6 +36,7 @@ extern struct map_t *global_unique_label_map;
 extern struct map_t *namespace_map;
 extern struct slot slots[256];
 extern struct append_section *append_sections, *append_tmp;
+extern char mem_insert_action[MAX_NAME_LENGTH*3 + 1024];
 extern int rombanks, verbose_mode, section_overwrite, symbol_mode, discard_unreferenced_sections;
 extern int emptyfill;
 extern int *banksizes, *bankaddress;
@@ -996,7 +997,10 @@ int parse_data_blocks(void) {
           /* amount of bytes */
           x = READ_T;
 
-          for (; x > 0; x--, i++)
+	  /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+	  sprintf(mem_insert_action, "Writing fixed data block from \"%s\".", obj_tmp->name);
+
+	  for (; x > 0; x--, i++)
             if (mem_insert(i, *(t++)) == FAILED)
               return FAILED;
         }
diff --git a/wlalink/compute.c b/wlalink/compute.c
index 370f693f..8f8614cf 100644
--- a/wlalink/compute.c
+++ b/wlalink/compute.c
@@ -10,6 +10,7 @@
 
 
 extern unsigned char *rom;
+extern char mem_insert_action[MAX_NAME_LENGTH*3 + 1024];
 extern int romsize, sms_checksum, smstag_defined, gb_checksum, gb_complement_check, snes_checksum, sms_header;
 extern int snes_rom_mode;
 
@@ -26,10 +27,17 @@ int reserve_checksum_bytes(void) {
       tag_address = 0x3FF0;
 
     if (romsize >= 0x2000) {
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "%s", "Reserving SMS ROM checmsum bytes");
+
       /* checksum */
       mem_insert(tag_address + 0xA, 0x0);
       mem_insert(tag_address + 0xB, 0x0);
+
       if (sms_checksum != 0) {
+	/* create a what-we-are-doing message for mem_insert*() warnings/errors */
+	sprintf(mem_insert_action, "%s", "Reserving SMS ROM region code byte");
+
 	/* region code */
 	mem_insert(tag_address + 0xF, 0x0);
       }
@@ -44,6 +52,9 @@ int reserve_checksum_bytes(void) {
       tag_address = 0x3FF0;
     
     if (romsize >= 0x2000) {
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "%s", "Reserving SMS ROM TMR SEGA bytes");
+
       /* tmr sega */
       mem_insert(tag_address + 0x0, 0);
       mem_insert(tag_address + 0x1, 0);
@@ -57,18 +68,28 @@ int reserve_checksum_bytes(void) {
   }
 
   if (gb_complement_check != 0) {
-    if (romsize >= 0x8000)
+    if (romsize >= 0x8000) {
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "%s", "Reserving GB ROM complement check byte");
+
       mem_insert(0x14D, 0);
+    }
   }
 
   if (gb_checksum != 0) {
     if (romsize >= 0x8000) {
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "%s", "Reserving GB ROM checmsum bytes");
+
       mem_insert(0x14E, 0);
       mem_insert(0x14F, 0);
     }
   }
 
   if (snes_checksum != 0) {
+    /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+    sprintf(mem_insert_action, "%s", "Reserving SNES ROM checmsum bytes");
+
     if ((snes_rom_mode == SNES_ROM_MODE_LOROM || snes_rom_mode == SNES_ROM_MODE_EXLOROM) && romsize >= 0x8000) {
       mem_insert(0x7FDC, 0);
       mem_insert(0x7FDD, 0);
@@ -155,6 +176,9 @@ int finalize_snes_rom(void) {
   
   
   if (snes_rom_mode == SNES_ROM_MODE_EXHIROM && romsize >= 0x410000) {
+    /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+    sprintf(mem_insert_action, "%s", "Mirroring SNES ROM header from $40ffb0-$40ffff -> $ffb0-$ffff");
+
     /* mirror the cartridge rom header from $40ffb0-$40ffff -> $ffb0-$ffff */
     for (i = 0; i < 5*16; i++)
       mem_insert(0xffb0 + i, rom[0x40ffb0 + i]);
diff --git a/wlalink/main.c b/wlalink/main.c
index f200cbf9..65a51f2b 100644
--- a/wlalink/main.c
+++ b/wlalink/main.c
@@ -25,7 +25,7 @@
 #define WLALINK_DEBUG
 */
 
-char version_string[] = "$VER: WLALINK 5.10a (20.2.2019)";
+char version_string[] = "$VER: WLALINK 5.10a (21.2.2019)";
 
 struct object_file *obj_first = NULL, *obj_last = NULL, *obj_tmp;
 struct reference *reference_first = NULL, *reference_last = NULL;
diff --git a/wlalink/memory.c b/wlalink/memory.c
index 6f123dee..4a8fbaf5 100644
--- a/wlalink/memory.c
+++ b/wlalink/memory.c
@@ -14,6 +14,7 @@ extern int romsize, banksize, section_overwrite;
 extern int pc_bank, pc_full, pc_slot, pc_slot_max;
 extern struct object_file *obj_tmp;
 
+char mem_insert_action[MAX_NAME_LENGTH*3 + 1024];
 int memory_file_id, memory_file_id_source, memory_line_number;
 
 
@@ -24,8 +25,11 @@ int mem_insert(int address, unsigned char data) {
     rom_usage[address]++;
     return SUCCEEDED;
   }
-  if (rom_usage[address] != 0)
+  if (rom_usage[address] != 0) {
     fprintf(stderr, "%s: MEM_INSERT: Overwrite at $%x (old $%.2x new $%.2x).\n", get_file_name(memory_file_id), address, rom[address], data);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
+  }
 
   rom_usage[address]++;
   rom[address] = data;
@@ -51,6 +55,8 @@ int mem_insert_ref(int address, unsigned char data) {
   if (address > romsize || address < 0) {
     fprintf(stderr, "%s: %s:%d: MEM_INSERT: Address $%x is out of the output range $0-$%x.\n",
 	    get_file_name(memory_file_id), get_source_file_name(memory_file_id, memory_file_id_source), memory_line_number, address, romsize);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
     return FAILED;
   }
   if (rom_usage[address] > 1 && rom[address] != data) {
@@ -60,6 +66,8 @@ int mem_insert_ref(int address, unsigned char data) {
     else
       fprintf(stderr, "%s: %s:[WLA]: MEM_INSERT: Overwrite at $%x (old $%.2x new $%.2x).\n",
 	      get_file_name(memory_file_id), get_source_file_name(memory_file_id, memory_file_id_source), address, rom[address], data);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
   }
 
   rom_usage[address]++;
@@ -74,6 +82,8 @@ int mem_insert_ref_13bit_high(int address, unsigned char data)
   if (address > romsize || address < 0) {
     fprintf(stderr, "%s: %s:%d: MEM_INSERT: Address $%x is out of the output range $0-$%x.\n",
 	    get_file_name(memory_file_id), get_source_file_name(memory_file_id, memory_file_id_source), memory_line_number, address, romsize);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
     return FAILED;
   }
   if (rom_usage[address] > 1 && (rom[address] & 0x1F) != data) {
@@ -83,6 +93,8 @@ int mem_insert_ref_13bit_high(int address, unsigned char data)
     else
       fprintf(stderr, "%s: %s:[WLA]: MEM_INSERT: Overwrite at $%x (old $%.2x new $%.2x).\n",
 	      get_file_name(memory_file_id), get_source_file_name(memory_file_id, memory_file_id_source), address, rom[address], data);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
   }
 
   rom_usage[address]++;
@@ -96,15 +108,22 @@ int mem_insert_pc(unsigned char d, int slot_current, int bank_current) {
 
   if (pc_slot >= pc_slot_max) {
     fprintf(stderr, "%s: MEM_INSERT: Overflow from slot %d.\n", get_file_name(memory_file_id), slot_current);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
     return FAILED;
   }
   if (pc_bank >= banksize) {
     fprintf(stderr, "%s: MEM_INSERT: Overflow from bank %d.\n", get_file_name(memory_file_id), bank_current);
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
     return FAILED;
   }
-  if (rom_usage[pc_full] != 0 && rom[pc_full] != d && section_overwrite == OFF)
+  if (rom_usage[pc_full] != 0 && rom[pc_full] != d && section_overwrite == OFF) {
     fprintf(stderr, "%s: MEM_INSERT: Overwrite at $%x, old $%x new $%x\n", get_file_name(memory_file_id), pc_full, rom[pc_full], d);
-
+    if (mem_insert_action[0] != 0)
+      fprintf(stderr, "   ^ %s\n", mem_insert_action);
+  }
+  
   if (section_overwrite == OFF)
     rom_usage[pc_full]++;
   rom[pc_full] = d;
diff --git a/wlalink/write.c b/wlalink/write.c
index d3ffc80d..0e9dbd24 100644
--- a/wlalink/write.c
+++ b/wlalink/write.c
@@ -1,3 +1,4 @@
+
 #include <ctype.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -11,7 +12,6 @@
 #include "../crc32.h"
 
 
-
 extern struct reference *reference_first, *reference_last;
 extern struct label *labels_first, *labels_last;
 extern struct label **sorted_anonymous_labels;
@@ -23,6 +23,7 @@ extern struct map_t *namespace_map;
 extern struct slot slots[256];
 extern unsigned char *rom, *rom_usage;
 extern unsigned char *file_header, *file_footer;
+extern char mem_insert_action[MAX_NAME_LENGTH*3 + 1024];
 extern int romsize, rombanks, banksize, verbose_mode, section_overwrite, symbol_mode;
 extern int pc_bank, pc_full, pc_slot, pc_slot_max, snes_rom_mode;
 extern int file_header_size, file_footer_size, *bankaddress, *banksizes;
@@ -251,6 +252,10 @@ int insert_sections(void) {
 	if (rom_usage[d] != 0 && rom[d] != s->data[d - pc_full])
 	  break;
       }
+
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing section %s: %s: %s.", get_file_name(s->file_id), get_source_file_name(s->file_id, s->file_id_source), s->name);
+
       if (d == i) {
 	for (i = 0; i < s->size; i++) {
 	  if (mem_insert_pc(s->data[i], s->slot, s->bank) == FAILED)
@@ -273,6 +278,10 @@ int insert_sections(void) {
       d = s->address;
       s->output_address = d;
       section_overwrite = ON;
+
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing section %s: %s: %s.", get_file_name(s->file_id), get_source_file_name(s->file_id, s->file_id_source), s->name);
+
       for (i = 0; i < s->size; i++) {
 	if (mem_insert(d + i, s->data[i]) == FAILED)
 	  return FAILED;
@@ -325,6 +334,10 @@ int insert_sections(void) {
       s->address = pc_bank;
       s->output_address = pc_full;
       section_overwrite = OFF;
+
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing section %s: %s: %s.", get_file_name(s->file_id), get_source_file_name(s->file_id, s->file_id_source), s->name);
+
       for (i = 0; i < s->size; i++) {
 	if (mem_insert_pc(s->data[i], s->slot, s->bank) == FAILED)
 	  return FAILED;
@@ -377,6 +390,10 @@ int insert_sections(void) {
       s->address = pc_bank;
       s->output_address = pc_full;
       section_overwrite = OFF;
+
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing section %s: %s: %s.", get_file_name(s->file_id), get_source_file_name(s->file_id, s->file_id_source), s->name);
+
       for (i = 0; i < s->size; i++) {
 	if (mem_insert_pc(s->data[i], s->slot, s->bank) == FAILED)
 	  return FAILED;
@@ -438,6 +455,9 @@ int insert_sections(void) {
 	s->output_address = pc_full;
 	section_overwrite = OFF;
 
+	/* create a what-we-are-doing message for mem_insert*() warnings/errors */
+	sprintf(mem_insert_action, "Writing section %s: %s: %s.", get_file_name(s->file_id), get_source_file_name(s->file_id, s->file_id_source), s->name);
+
 	for (i = 0; i < s->size; i++)
 	  if (mem_insert_pc(s->data[i], s->slot, s->bank) == FAILED)
 	    return FAILED;
@@ -473,6 +493,10 @@ int insert_sections(void) {
 		get_source_file_name(s->file_id, s->file_id_source), s->name, s->size, s->bank);
 	return FAILED;
       }
+
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing section %s: %s: %s.", get_file_name(s->file_id), get_source_file_name(s->file_id, s->file_id_source), s->name);
+
       for (i = 0; i < s->size; i++) {
 	if (mem_insert_pc(s->data[i], s->slot, s->bank) == FAILED)
 	  return FAILED;
@@ -761,6 +785,9 @@ int fix_references(void) {
       memory_file_id_source = r->file_id_source;
       memory_line_number = r->linenumber;
 
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing reference %s: %s:%d: %s.", get_file_name(r->file_id), get_source_file_name(r->file_id, r->file_id_source), r->linenumber, r->name);
+
       /* direct 16-bit */
       if (r->type == REFERENCE_TYPE_DIRECT_16BIT || r->type == REFERENCE_TYPE_RELATIVE_16BIT) {
         mem_insert_ref(x, i & 0xFF);
@@ -769,7 +796,7 @@ int fix_references(void) {
       /* direct 13-bit */
       else if (r->type == REFERENCE_TYPE_DIRECT_13BIT) {
         mem_insert(x, i & 0xFF);
-		mem_insert_ref_13bit_high(x + 1, (i >> 8) & 0xFF);
+	mem_insert_ref_13bit_high(x + 1, (i >> 8) & 0xFF);
       }
       /* direct / relative 8-bit with a definition */
       else if (l->status == LABEL_STATUS_DEFINE) {
@@ -814,6 +841,9 @@ int fix_references(void) {
       memory_file_id_source = r->file_id_source;
       memory_line_number = r->linenumber;
 
+      /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+      sprintf(mem_insert_action, "Writing reference %s: %s:%d: %s.", get_file_name(r->file_id), get_source_file_name(r->file_id, r->file_id_source), r->linenumber, r->name);
+
       /* direct 16-bit */
       if (r->type == REFERENCE_TYPE_DIRECT_16BIT) {
         i = (int)l->address;
@@ -1364,6 +1394,9 @@ int compute_pending_calculations(void) {
     memory_file_id_source = sta->file_id_source;
     memory_line_number = sta->linenumber;
 
+    /* create a what-we-are-doing message for mem_insert*() warnings/errors */
+    sprintf(mem_insert_action, "Writing pending calculation %s: %s:%d.", get_file_name(sta->file_id), get_source_file_name(sta->file_id, sta->file_id_source), sta->linenumber);
+
     if (sta->type == STACKS_TYPE_8BIT) {
       if (k < -128 || k > 255) {
 	fprintf(stderr, "%s: %s:%d: COMPUTE_PENDING_CALCULATIONS: Result (%d/$%x) of a computation is out of 8-bit range.\n",
